!----------------------------------------------------------------------
!! Produit matrice/matrice: C = A * B
!----------------------------------------------------------------------
PROGRAM PROD_MAT

  IMPLICIT NONE

  INTEGER, PARAMETER           :: m = 801, n = 701
  REAL(KIND=8), DIMENSION(m,n) :: a
  REAL(KIND=8), DIMENSION(n,m) :: b
  REAL(KIND=8), DIMENSION(m,m) :: c
  INTEGER                      :: i, j, k, ir, t1, t2
  REAL(KIND=8)                 :: temps, t_cpu_0, t_cpu_1, t_cpu

  ! Temps CPU de calcul initial
  CALL CPU_TIME(t_cpu_0)

  ! Temps elapsed de reference
  CALL SYSTEM_CLOCK(count=t1, count_rate=ir)

  ! Intialisation des matrices A, B et C
  DO j=1,n
     DO i=1,m
        a(i,j) = REAL(i+j, KIND=8)
     ENDDO
  ENDDO

  DO j=1,m
     DO i=1,n
        b(i,j) = REAL(i-j, KIND=8)
     ENDDO
  ENDDO

  DO j=1,m
     DO i=1,m
        c(i,j) = 0.0_8
     ENDDO
  ENDDO

  ! Produit de matrices
  DO j=1,m
     DO k=1,n
        DO i=1,m
           c(i,j) = c(i,j) + a(i,k)*b(k,j)
        ENDDO
     ENDDO
  ENDDO

  ! Temps elapsed final
  CALL SYSTEM_CLOCK(count=t2, count_rate=ir)
  
  temps = REAL(t2-t1, KIND=8)/REAL(ir, KIND=8)

  ! Temps CPU de calcul final
  CALL CPU_TIME(t_cpu_1)
  
  t_cpu = t_cpu_1 - t_cpu_0

  ! Impression du resultat
  PRINT'(//, 3x, "Valeurs de m et n   : ", i5, i5/,              &
           & 3x, "Temps elapsed       : ", 1pe10.3, " sec" ,/ , &
           & 3x, "Temps CPU           : ", 1pe10.3, " sec" ,/ , &
           & 3x, "Resultat partiel    : ", 2(1pe10.3, 1x), " ... ", & 
           & 2(1pe10.3, 1x), //)', &
           & m, n, temps, t_cpu, c(2,2), c(3,3), c(m-2,m-2), c(m-1,m-1)  
!----------------------------------------------------------------------
END PROGRAM PROD_MAT
!----------------------------------------------------------------------
